﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using OpenTK;

using OpenTK.Graphics.OpenGL;
using OpenTK.Audio;
using OpenTK.Audio.OpenAL;
using OpenTK.Input;



namespace WindowsFormsApplication2
{

    public partial class Form1 : Form
    {
        float AngleX = 0;
        float AngleY = 15;
        float AngleZ = 0;
        
        const float AngleDl = 5;

        Rectangle p;
        private double[] m = new double[16];
        uint[] buf = new uint[128]; // буфер выбора

        public Form1()
        {
            InitializeComponent();
        }

        private void glControl1_Resize(object sender, EventArgs e)
        {
            SetupViewport();
            glControl1.Invalidate();
        }

        private void SetupViewport()
        {
            GL.Viewport(0, 0, glControl1.Width, glControl1.Height); 

            GL.MatrixMode(MatrixMode.Projection);
            GL.LoadIdentity();
            GL.Ortho(-2, 2, -2, 2, -2, 2);
            GL.MatrixMode(MatrixMode.Modelview);
        }


        private void glControl1_Paint(object sender, PaintEventArgs e)
        {
            // определение текущего режима OpenGL
            int[] aMode = new int[1];
            GL.GetInteger(GetPName.RenderMode,  aMode);

            RenderingMode mode = (RenderingMode)aMode[0];

            if (mode == RenderingMode.Select)
            {
                GL.MatrixMode(MatrixMode.Projection);
                // сохранение матрицы проекций для формирования изображения
                // в стеке матриц и в переменной M
                GL.PushMatrix();

                //Matrix4 m4 = new Matrix4();
                GL.GetDouble( GetPName.ProjectionMatrix,  m);
                // формирование матрицы проекций для режима выбора
                GL.LoadIdentity();

                int[] vp = new int[4];
                GL.GetInteger(GetPName.Viewport, vp);
                Tao.OpenGl.Glu.gluPickMatrix(p.X, vp[3] - p.Y, 5, 5, vp);

                GL.MultMatrix(m);

                GL.MatrixMode(MatrixMode.Modelview);

                // инициализация стека имен
                GL.InitNames();
                GL.PushName(0);
            }
            
            // очистка буферов цвета и глубины
            GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);

            // поворот изображения
            GL.LoadIdentity();
            GL.Rotate(AngleX, 1.0, 0.0, 0.0);
            GL.Rotate(AngleY, 0.0, 1.0, 0.0);
            GL.Rotate(AngleZ, 0.0, 0.0, 1.0);

            // формирование изображения
            if (mode == RenderingMode.Select)
                GL.LoadName(1);

            GL.Color3(0f, 0f, 1f);
            GL.Begin(BeginMode.Triangles);
                GL.Vertex3(0,0,0);
                GL.Vertex3(-1,-1,0);
                GL.Vertex3(-1,1,0);
            GL.End();


            if (mode == RenderingMode.Select)
                GL.LoadName(2);
            GL.Color3(1f, 0f, 0);
            GL.Begin(BeginMode.Triangles);
                GL.Vertex3(0,0,0);
                GL.Vertex3(1,1,0);
                GL.Vertex3(1,-1,0);
            GL.End();

            if (mode == RenderingMode.Select)
                GL.LoadName(3);
            GL.Color3(0f, 1f, 1f);
            GL.Begin(BeginMode.Triangles);
                GL.Vertex3(0,0,1);
                GL.Vertex3(-1,-1,1);
                GL.Vertex3(-1,1,1);
            GL.End();


            if (mode == RenderingMode.Select)
                GL.LoadName(4);
            GL.Color3(1f, 1f, 0f);
            GL.Begin(BeginMode.Triangles);
                GL.Vertex3(0,0,1);
                GL.Vertex3(1,1,1);
                GL.Vertex3(1,-1,1);
            GL.End();


            // завершение формирования изображения
            GL.Flush();
            GL.Finish();

            if (mode == RenderingMode.Select)
            {
                int rec_count = GL.RenderMode(RenderingMode.Render);
        
                // восстановление матрицы проекции из стека
                GL.MatrixMode(MatrixMode.Projection);
                GL.PopMatrix();
                GL.MatrixMode(MatrixMode.Modelview);
        
                // вывод содержания буфера выбора
                uint obj_count = 0;
                uint el = 0;
                string s = "";
                for (int i = 1; i <= rec_count; ++i)
                {
                    obj_count = buf[el];
                    s += String.Format("{0}, {1}, {2}", obj_count, buf[el + 1], buf[el + 2]);
                    for (int obj=1; obj <= obj_count; ++obj)
                        s += String.Format(", {0}", buf[el + 2 + obj]);
                    s += "\n";
                    el += obj_count + 3;
                }
                if (rec_count > 0)
                    MessageBox.Show(s);
            }
            else
                glControl1.SwapBuffers();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetupViewport();
            GL.ClearColor(1f, 1f, 1f, 1f); // цвет фона
            GL.Enable(EnableCap.DepthTest);

            GL.SelectBuffer(buf.Count(), buf); // создание буфера выбора
        }

        private void glControl1_KeyDown(object sender, KeyEventArgs e)
        {
            switch(e.KeyCode)
            {
                case Keys.Insert: 
                    AngleX += AngleDl;
                    break;
                case Keys.Delete: 
                    AngleX -= AngleDl;
                    break;
                case Keys.Home: 
                    AngleY += AngleDl;
                    break;
                case Keys.End: 
                    AngleY -= AngleDl;
                    break;
                case Keys.Prior: 
                    AngleZ += AngleDl;
                    break;
                case Keys.Next: 
                    AngleZ -= AngleDl;
                    break;
            }
            glControl1.Invalidate(); 
        }

        private void glControl1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
        {
              p.X = e.X;
              p.Y = e.Y;
              GL.RenderMode(RenderingMode.Select);
              glControl1.Invalidate();
        }
    }
}
