unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.dfm}
uses OpenGL, Unit2;
//      
Const
  AngleDl=5;
//  
var
  hrc: HGLRC;
  dc: HDC;
  //       
  AngleX, AngleY, AngleZ: integer;

var
  SB : Array [0..128] of GLuint;//  
  P: TPoint;
  M : Array [0..3, 0..3] of GLdouble;


procedure TForm1.FormCreate(Sender: TObject);
var
  PFD: TPixelFormatDescriptor;
  i: integer;
begin
  //        GetDC
  dc:=GetDC(handle);
  //   pfd
  FillChar(PFD, SizeOf(PFD),0);
  pfd.dwFlags  := PFD_DRAW_TO_WINDOW
    or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
  //        
  i:=ChoosePixelFormat(dc, @PFD);
  if i=0 then
    raise Exception.Create('    !');
  //      ,   
  // -  ChoosePixelFormat
  if not SetPixelFormat(dc, i, @PFD) then
    raise Exception.Create('     !');
  //      OpenGL
  //         
  hrc:=wglCreateContext(dc);
  if hrc=0 then
    raise Exception.Create('    !');
  //    
  if not wglMakeCurrent(dc, hrc) then
    raise
      Exception.Create('     !');
  glEnable(GL_DEPTH_TEST);

  AngleX := 15;

  glSelectBuffer(SizeOf (sb), @sb); //   
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if not wglMakeCurrent(0, 0) then
    raise Exception.Create(
      '     !');
  if not wglDeleteContext(hrc) then
    raise Exception.Create('    !');
  if ReleaseDC(Form1.Handle, dc)=0 then
    raise Exception.Create('   ');
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  case Key of
    VK_INSERT: inc(AngleX, AngleDl);
    VK_DELETE: dec(AngleX, AngleDl);
    VK_HOME: inc(AngleY, AngleDl);
    VK_END: dec(AngleY, AngleDl);
    VK_PRIOR: inc(AngleZ, AngleDl);
    VK_NEXT: dec(AngleZ, AngleDl);
  end;
  //     
  InvalidateRect(Handle, nil, False);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  //      P
  //     
  p.x:=x; p.y:=y;
  glRenderMode(GL_SELECT);
  InvalidateRect(Handle, nil, False);
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  i : GLint;
  Count, Mode: GLuint;
  vp : Array [0..3] of GLint;
  rec_count: integer;
  obj, obj_count, el: integer;
  s: string;
begin
  //    OpenGL
  glGetIntegerv(GL_RENDER_MODE, @Mode);
  if Mode=GL_SELECT then begin
    glMatrixMode(GL_PROJECTION);
    //      
    //       M
    glPushMatrix;
    glGetDoublev(GL_PROJECTION_MATRIX, @M);
    //      
    glLoadIdentity;
    glGetIntegerv(GL_VIEWPORT, @vp);
    gluPickMatrix(p.x, vp[3]-p.y, 5, 5, @vp);
    glMultMatrixd(@M);
    glMatrixMode(GL_MODELVIEW);
    //   
    glInitNames;
    glPushName(0);
  end;
  //   
  glClearColor (0.5, 0.5, 0.75, 1.0); //  
  glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity;
  //     ,
  //    
  glRotatef(AngleX, 1.0, 0.0, 0.0);
  glRotatef(AngleY, 0.0, 1.0, 0.0);
  glRotatef(AngleZ, 0.0, 0.0, 1.0);
  //  
  if Mode=GL_SELECT then glLoadName(1);
   glColor3f(0,0,1);
   glBegin(GL_TRIANGLES);
     glVertex3f(0,0,0);
     glVertex3f(-1,-1,0);
     glVertex3f(-1,1,0);
   glEnd;
  if Mode=GL_SELECT then glLoadName(2);
  glColor3f(1,0,0);
  glBegin(GL_TRIANGLES);
    glVertex3f(0,0,0);
    glVertex3f(1,1,0);
    glVertex3f(1,-1,0);
  glEnd;
  if Mode=GL_SELECT then glLoadName(3);
  glColor3f(0,1,1);
  glBegin(GL_TRIANGLES);
    glVertex3f(0,0,1);
    glVertex3f(-1,-1,1);
    glVertex3f(-1,1,1);
  glEnd;
  if Mode=GL_SELECT then glLoadName(4);
  glColor3f(1,1,0);
  glBegin(GL_TRIANGLES);
    glVertex3f(0,0,1);
    glVertex3f(1,1,1);
    glVertex3f(1,-1,1);
  glEnd;
  if Mode=GL_SELECT then
  begin
    rec_count:=glRenderMode(GL_RENDER);
    //     
    glMatrixMode(GL_PROJECTION);
    glPopMatrix;
    glMatrixMode(GL_MODELVIEW);
    //    
    obj_count := 0;
    el := 0;
    with Form2.Memo1.Lines do begin
      Clear;
      for i:=1 to rec_count do begin
        obj_count := sb[el];
        s := IntToStr(obj_count) + ','
          + IntToStr(sb[el + 1]) + ','
          + IntToStr(sb[el + 2]);
        for obj := 1 to obj_count do
          s := s + ',' + IntToStr(sb[el + 2 + obj]);
        el := el + (obj_count + 3);
        Add(s);
      end;
    end;
  end
  else
    SwapBuffers(DC);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
 //   
 glViewport(0, 0, ClientWidth, ClientHeight);

 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 glOrtho(-2, 2, -2, 2, -2, 2);
 glMatrixMode(GL_MODELVIEW);

 //  
 InvalidateRect(Handle, nil, False);

 form2.Left := left;
 form2.Top := top + height;

end;

end.
